#ifndef _SIMPLEENTITYFACTORY_DOT_H_INCLUDED_
#define _SIMPLEENTITYFACTORY_DOT_H_INCLUDED_

// simple pooled entity factory.
class SimpleEntityFactory:public snbfrx::EntityFactory
{
public:
    // constructor, takes in a pool size parameter specifying 
    // the number of entities in the pool
    SimpleEntityFactory( int poolsize = 10 );
    
    // destructor
    virtual ~SimpleEntityFactory();

    virtual snbfrx::Entity* createEntity();
    virtual void releaseEntity( snbfrx::Entity* pentity );

private:
    // vector of free unused entities.
    std::vector< SimpleEntity* > m_freeEntity;

    // set of used entities.
    std::set< SimpleEntity* >    m_usedEntity;
};
#endif